#ifndef AIState_H
#define AIState_H

#include "GameStateModule.H"
#include "GfxModule.H"
struct AIState{

	GameStateModule *gsm;
	GfxModule       *gfxm; // !=0 : gfx used
	bool just_drew;  // just drew a gfx frame
	bool quit;       // true => quit game
	bool error;      // true <=> error occurred
	AIState(GameStateModule *gsm_, GfxModule *gfxm_) : gsm(gsm_), gfxm(gfxm_) {
		just_drew = quit = error = false;
	}
};
#endif

