
#include "Global.H"

#include "Mineral.H"

Vector<Mineral*> Mineral::minerals;
sint4 Mineral::tilepoints;
//std::set<Loc> Mineral::accessLocs;
std::map<Loc, GameObj* > Mineral::accessLocs;

Mineral& Mineral::addMineral(GameObj& gob){
	/*FORALL(minerals,it){
		if (&(*it)->gob==&gob) {std::cout<<"addMineral: mineral already added"<<std::endl; return (**it);}
	}*/
	std::cout <<"addMineral nr:"<<minerals.size()<<std::endl;
	Mineral* mineral=new Mineral(gob,minerals.size());
	minerals.push_back(mineral);
	
	Loc p1((*gob.sod.x/tilepoints)*tilepoints,(*gob.sod.y/tilepoints)*tilepoints);
	Loc p;
	accessLocs[p1]=&gob;
	
/*	p=Loc(p1.x+tilepoints,p1.y);
	accessLocs.insert(p);
	loc2gob[p]=&gob;
	
	p=Loc(p1.x+tilepoints,p1.y+tilepoints);
	accessLocs.insert(p);
	loc2gob[p]=&gob;
	
	p=Loc(p1.x,p1.y+tilepoints);
	accessLocs.insert(p);
	loc2gob[p]=&gob;*/
	return *mineral;
}
void Mineral::selectMinerals(sint4 mapsize){
	std::map<Loc,GameObj*> tmp;
	FORALL(accessLocs,it){
		bool up,down,left,right;
		up=down=left=right=false;
		if (it->first.x<=tilepoints) left=true;
		if (it->first.y<=tilepoints) up=true;
		if (it->first.x>=mapsize-2*tilepoints) right=true;
		if (it->first.y>=mapsize-2*tilepoints) down=true;
		FORALL(accessLocs,it2) if (std::max(abs(it->first.x-it2->first.x),abs(it->first.y-it2->first.y))<=2*tilepoints){
			if (it2->first.x<it->first.x) left=true;
			if (it2->first.x>it->first.x) right=true;
			if (it2->first.y<it->first.y) up=true;
			if (it2->first.y>it->first.y) down=true;
		}
		if (!(up && down && left && right)) tmp[it->first]=it->second; 
	}
	accessLocs=tmp;
}