#include <cmath>

#include "Global.H"
#include "Worker.H"

vector<Worker*> Worker::w;
GameObj* Worker::commCenter;

void Worker::setPath(Loc p){
		//if (path) delete path;
		list<Loc>* new_path=&graph.shortestPath(loc, p);
		assert(!new_path->empty());
		setPath(new_path);
}
void Worker::setPath(list<Loc>* new_path){
	path=new_path;
	path->pop_front();
	path->push_front(Loc((*commCenter->sod.x1+*commCenter->sod.x2)/2,
							(*commCenter->sod.y1+*commCenter->sod.y2)/2));
	normalizePath();
	cout <<"found path";
		FORALL(*path,it){
			cout <<"==>("<<(*it).x<<", "<<(*it).y<<")";
		}
		cout<<endl;
}
bool Worker::setEmPath(Loc p){
		emPath=&graph.shortestPath(loc, p);
		//if (emPath) {delete emPath;emPath=NULL;}
		if(emPath->empty()) return false;
		emergencyPath();
		
		cout <<"found Emergency path";
		FORALL(*emPath,it){
			cout <<"==>("<<(*it).x<<", "<<(*it).y<<")";
		}
		cout<<endl;
		return true;
}

/*void Worker::onDoneJob(){
		if (state==FETCH) cout<<id<< " fetch "<<++fetched<<endl;
		if (state==MINE) cout<<"finished mining"<<endl;
		switch (state){
			case DROP:setPath(Loc(*res->sod.x,*res->sod.y)); setState(FETCH);break;
			case FETCH: setState(MINE);break;
			case MINE: setPath(begin);setState(BACK);cout<<loc<<"going back ==>"<<target<<endl;break;
			case BACK: setState(DROP);break;
			case AVOID: setState(previous); break;
			default: break;
		}

	}*/
	
// Zarzyk - to nie powinno tu byc
Loc rotate(Loc l, double angle){
	return Loc((sint4)(l.x*cos(angle) - l.y*sin(angle)),(sint4)(l.x*sin(angle) + l.y*cos(angle)));
}
void Worker::avoid(){
		static sint4 avoids=0;
		if (++avoids%10==0) cout <<"AVOIDS : "<<avoids<<endl;	
		avoidCount=2;
		
		GameObj* debil=graph.findClosest(*obj);
		if (!debil || rand()%20==0){
			++staticAvoids;
			//cout << "obstacle not found" <<endl;
			target.x=loc.x+rand()%30-15;
			target.y=loc.y+rand()%30-15;
		} else {
			//cout << "obstacle found "<<Loc(*debil->sod.x,*debil->sod.y) <<endl;
			//Loc a(*debil->sod.y-loc.y,loc.x-*debil->sod.x);
			Loc a(loc.x - *debil->sod.x, loc.y- *debil->sod.y);
			a.x*=1;
			a.y*=1;
			a=rotate(a,(double)(rand()%100)/100*M_PI/4+M_PI/4);
			if (pathStepAlmostReached()&& !pathEnded()) setNextPathStep();
			setTarget(Loc(loc.x+a.x,loc.y+a.y));
		}
		moveTo(target);
}

/*void Worker::setAction() {
		if (state==BACK){ }
		if (avoidCount>1) { avoidCount--; return;}
		if (avoidCount==1) { onDoneJob(); avoidCount--;return;}
		if (state==MINE){
			onDoneJob();
			return;
			Vector<sint4>params;
			params.push_back(gsm.get_game().get_cplayer_info().get_id(res));
			obj->component("pickaxe")->set_action("mine",params);
			cout <<id << " mined "<< obj->get_int("minerals")<<endl;
			if (obj->component("pickaxe")->get_int("active") == 0 && ( obj->get_int("minerals")>0 || fetched==1)){
				onDoneJob();
				return;
			}

		}
		if (state==DROP){
			onDoneJob();
		}
		if (state==BACK || state==FETCH){
			if (path->empty()){ obj->set_action("stop", Vector<sint4>()); return;}
			if (!hasTarget() && hasPath()) { current = path->begin();}
			if (isReachedTarget() && current!=path->end()) {cout << "nastepny"<<endl; ++current;}
//			if (!(*obj->sod.is_moving)) cout << "zderzenie =======" <<endl;
			if (!reachedRes() && !isReachedTarget() && *obj->sod.speed==0 && last_speed>0 && turn>0){
			//	cout <<" zderzenie ==="<<endl;
				avoid();
				return;
			}
			if ((isReachedTarget() && current==path->end())||(state==FETCH && reachedRes())) { obj->set_action("stop",Vector<sint4>());onDoneJob();return;}
			if (isReachedTarget()|| *obj->sod.speed==0){
				setTarget(*current);
				Vector<sint4> params;
				params.push_back(target.x);
				params.push_back(target.y);
				//cout << "position :"<<loc<<" setting target ==>"<<target<<endl;
				params.push_back(*obj->sod.max_speed);
				obj->set_action("move",params);
			}
		}
		last_speed=*obj->sod.speed;
		++turn;
}*/
void Worker::update(){
	last_speed=*obj->sod.speed;
}

void Worker::setAction(){
	//cout << "worker "<<id<<": setAction"<<endl;
	switch(state){
		case MOVE_TO:
		//cout << "moving " << obj->get_int("speed") <<" "<<last_speed<<endl;
			if (targetReached()){ //path target reached,start next one
				if (pathEnded()){	//all path targets done!start mining(never gonna happen)
					stop();
					setState( MINE );
				} 
				else{
					setNextPathStep();
					moveTo(target);
				}					
			}else {
				
				if (Game::distance(*obj,*res)<=2){
					
					//cout << "resource reached"<<endl;
					stop();
					setState( MINE );
					
				} else if (last_speed>*obj->sod.speed) {	//collision!
					//cout << "hit something"<<endl;
					setState(AVOID);
					avoid();
				} else if (*obj->sod.speed==0) moveTo(target);
			}	 
			break;
			
			
		case MOVE_BACK:
		//cout << "moving " << obj->get_int("speed") <<" "<<last_speed<<" "<<*obj->sod.is_moving<<endl;
			if (targetReached()){ //path target reached,start next one
				
				if (pathEnded()){	//all path targets done!start unloading
					//cout <<"target reached, path empty"<<endl;
					stop();
					setState(UNLOAD);
				} else{
					//cout <<"target reached, setting next"<<endl;
					setNextPathStep();
					moveTo(target);
				}					
			}else {
				
				if (Game::distance(*obj,*commCenter)<=2){
					stop(); 
					setState(UNLOAD);
				} else if (last_speed>*obj->sod.speed){
					setState(AVOID);
					avoid();
				} else if (Game::distance(*obj, *commCenter)<=16 && !pathEnded()){
					previousRPathIt = rPathIt;
					baseEncountered = true;
					//cout << " OO! Base!:) remembering target:"<<(*previousRPathIt)<<endl; 
					setEndPathStep();
					moveTo(target);
				} else if (*obj->sod.speed==0) { 
					moveTo(target);
				}
			}
				
			break;
				
		case MINE:
			if (obj->get_int("minerals") >=10){	//mining ended!!!!TODO: nie chce wracac 
				//obj->component("pickaxe")->set_action("stop",Vector<sint4>());
				//stop();
				setState(MOVE_BACK);
				reversePath();
				moveTo(target);
				isWorking=false;
				//setPath(begin);			//TODO: command Center
			} else if (!isWorking) { mine();isWorking=true;}
			//else {cout <<"worker "<<id<<": got minerals:"<<obj->get_int("minerals")<<endl;}
			
			break;
		case UNLOAD:
			if (obj->get_int("minerals") == 0){	//unloading ended
				setState(MOVE_TO);
				//normalizePath();
				switchPath();
				isWorking=false;
				moveTo(target);
				static PlayerInfo& my_info=gsm.get_game().get_cplayer_info();
				cout << "====SCORE : " << my_info.global_obj("player")->get_int("minerals")<<endl;
				//setPath(Loc(*res->sod.x, *res->sod.y));
			}
			else if (!isWorking){unload();isWorking=true;}
			break;
		
		case AVOID:
			if (targetReached()){
				//cout << "end avoid" <<endl;
				setState(previousState);
				//staticAvoids=0;
				setPathStep();
				moveTo(target);
			}else if (previousState==MOVE_BACK && Game::distance(*obj,*commCenter)<=2){
					//cout <<"target not reached, path empty"<<endl;
				previousRPathIt = rPathIt;
				baseEncountered = true;
				stop();
				setState(UNLOAD);
			} else if (previousState==MOVE_TO && Game::distance(*obj,*res)<=2){
					//cout << "resource reached"<<endl;
					stop();
					setState( MINE );
					
			}else if(staticAvoids>=3 && !pathEnded()){
				staticAvoids=0;
				setPathStep();
				setState(EM_AVOID);
				if (!setEmPath(target)) { setState(AVOID);avoid();} else
				
				moveTo(target);
			}
			else{
				if (*obj->sod.speed==0) {
					setState(AVOID);
					avoid();
				}
			}
			break;
		case EM_AVOID:
			if (targetReached()){ //path target reached,start next one
				if (pathEnded()){
					setState( previousState );
					setPathStep();
					moveTo(target);
				} 
				else{
					setNextPathStep();
					moveTo(target);
				}					
			} else if (previousState==MOVE_BACK && Game::distance(*obj,*commCenter)<=2){
					//cout <<"target not reached, path empty"<<endl;
				stop();
				setState(UNLOAD);
			} else if (previousState==MOVE_TO && Game::distance(*obj,*res)<=2){
					//cout << "resource reached"<<endl;
					stop();
					setState( MINE );
					
			}else if (last_speed>*obj->sod.speed) {	//collision!
					//cout << "hit something"<<endl;
					setState(AVOID);
					avoid();
			} else if (*obj->sod.speed==0) moveTo(target);
				 
			break;
		default:/*impossible*/
			cout <<"impossible state"<<endl;exit(-1);
	}
	update();
}
void Worker::gather(){
	cout <<"Worker "<<id<<": gather"<<endl;
	setState(MOVE_TO);
	setPath(Loc(*res->sod.x, *res->sod.y)); 
}
void Worker::gather(list<Loc> *new_path){
	cout <<"Worker "<<id<<": gather"<<endl;
	setState(MOVE_TO);
	setPath(new_path); 
}
void Worker::moveTo(Loc to){
//	cout << "Worker:moveTo:"<<to<<"at speed: "<<*obj->sod.max_speed<<", I'm at:"<<loc<<" resource at:("<<*res->sod.x<<", "<<*res->sod.y<<")"<<endl;
//	cout << " distance to resource=="<<Game::distance(*obj, *res)<<endl;
	Vector<sint4> params;
	params.push_back(to.x);
	params.push_back(to.y);
	params.push_back(*obj->sod.max_speed);
	obj->set_action("move",params);
}
void Worker::mine(){
	Vector<sint4> params;
	static PlayerInfo& my_info=gsm.get_game().get_cplayer_info();
	params.push_back(my_info.get_id(res));
	obj->component("pickaxe")->set_action("mine",params);
}
void Worker::unload(){
	//cout <<"unloading..."<<endl;
	Vector<sint4> params;
	static PlayerInfo& my_info=gsm.get_game().get_cplayer_info();
	params.push_back(my_info.get_id(commCenter));
	obj->set_action("return_resources", params);
}

void Worker::stop(){
	//cout<<"stop"<<endl;
	obj->set_action("stop",Vector<sint4>());
}
/*static*/
Worker* Worker::getWorker(Graph& g, GameStateModule&gsm,GameObj *gob){
		Loc loc(*gob->sod.x, *gob->sod.y);
		for (uint4 i=0;i<w.size();++i) if (w[i]->obj==gob) { w[i]->loc=loc; return w[i];  } 
		cout << "============**************======== new worker created" << endl;
		Worker *nw=new Worker(g,gsm,loc,w.size());
		nw->obj=gob;
		w.push_back(nw);
		return nw;
}
