

#ifndef Mineral_H
#define Mineral_H
#include "Global.H"
#include <set>
#include <map>
#include "GameObj.H"
#include "TerrainBase.H"

typedef TerrainBase::Loc Loc;
class MineralGroup;

class Mineral
{
public:
/////////////////////////////////////////////////////
// public associations
/////////////////////////////////////////////////////

	static Vector<Mineral*> minerals;
	GameObj& gob;
	sint4 id;
	Loc loc;
//MineralGroup& mineralGroup;

/////////////////////////////////////////////////////
// public methods
/////////////////////////////////////////////////////
Mineral(GameObj& _gob,sint4 _id):gob(_gob),id(_id){
	loc=Loc(*gob.sod.x,*gob.sod.y);
}

static Mineral& addMineral(GameObj& gob);
static void selectMinerals(sint4);
//static std::set<Loc> accessLocs;
static std::map<Loc, GameObj*> accessLocs;
static sint4 tilepoints;

};

#endif 

