

#include "WorkerCoordinator.H"
#include "AIState.H"
#include "Options.H"
#include "Graph.H"
#include "Mineral.H"
WorkerCoordinator::WorkerCoordinator(AIState &_state, Graph& _graph):state(_state), graph(_graph){
	
}
void WorkerCoordinator::setAction(){
	const Game &game = state.gsm->get_game();
  	const sint4 cid = game.get_client_player(); 
  	const Game::ObjCont &objs = game.get_objs(cid);
	FORALL (objs, it) {
    GameObj *gob = (*it)->get_GameObj();
    static std::map<GameObj*, int> used;
	static	set<Loc> mineralsSet;
	static	list<Loc> *path;
	static int init=0;
	if (!init) FORALL(Mineral::minerals, it){
		init=1;		
		mineralsSet.insert(Loc(*(*it)->gob.sod.x, *(*it)->gob.sod.y));
		cout <<"mineral pos : "<<Loc(*(*it)->gob.sod.x, *(*it)->gob.sod.y)<<endl;
	}
    if (gob && gob->sod.in_game && *gob->sod.x >= 0 && !gob->is_dead()) {
	    if (gob->bp_name()!="worker") continue;
		bool attr;
		Options::get("-attr",attr);
	
		if (attr){
			cout << "col" << *gob->get_int_ptr("targ_dist") << endl;
			Vector<std::string> v;
			gob->attr_names(v);
			cout << "attr" << endl;
			FORALL(v,it){
				cout << *it << endl;
			}
	    }
		Worker *w=Worker::getWorker(graph,*state.gsm,gob);
	
		
		if (!w->hasState()){
			
			//sint4 d=1000000,tmp;
			GameObj *res=NULL;
			
			path=&graph.shortestPath(w->loc, mineralsSet);
			assert(!path->empty());
			cout <<"found path:";
			FORALL(*path,it){
				cout <<" ==> "<<*it;
			}
			cout<<endl;
			FORALL(Mineral::minerals, it){
				if (Loc(*(*it)->gob.sod.x, *(*it)->gob.sod.y)==path->back()) {
					res = &(*it)->gob; break;
				}
			}
			assert (res!=NULL);
			w->setResource(res);
			w->gather(path);
			
			
			if (++used[res]>1) mineralsSet.erase(path->back());
			
			/*FORALL (Mineral::accessLocs, it) {
				GameObj *gob = it->second;
				if (used[gob]<1 && (tmp=distance2(Loc(w->loc.x,w->loc.y),Loc(*gob->sod.x,*gob->sod.y)))<d){
					d=tmp;
					res=gob;
				}
				
			}*/
			
			//used[res]++;
			//w->setResource(res);
			//w->gather();
		}
		w->setAction();
    }
  }
}
